orte/mca/oob/oob.h File Reference.TH "orte/mca/oob/oob.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/oob/oob.h \- Contains the internal functions and typedefs for the use of the oob. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'mca/gpr/gpr_types.h'\fP
.br
\fC#include 'mca/oob/oob_types.h'\fP
.br
\fC#include 'mca/oob/base/base.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_OOB_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in components that are of type oob v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef struct \fBmca_oob_1_0_0_t\fP \fBmca_oob_1_0_0_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.ti -1c
.RI "typedef \fBmca_oob_1_0_0_t\fP \fBmca_oob_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef char *(* \fBmca_oob_base_module_get_addr_fn_t\fP )(void)"
.br
.RI "\fIImplementation of mca_oob_base_module_get_addr(). \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_set_addr_fn_t\fP )(const orte_process_name_t *, const char *uri)"
.br
.RI "\fIImplementation of mca_oob_base_module_set_addr(). \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_ping_fn_t\fP )(const orte_process_name_t *, const char *uri, const struct timeval *tv)"
.br
.RI "\fIImplementation of \fBmca_oob_ping()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_send_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.br
.RI "\fIImplementation of \fBmca_oob_send()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_recv_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.br
.RI "\fIImplementation of \fBmca_oob_recv()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_send_nb_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIImplementation of \fBmca_oob_send_nb()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_recv_nb_fn_t\fP )(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIImplementation of \fBmca_oob_recv_nb()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_recv_cancel_fn_t\fP )(orte_process_name_t *peer, int tag)"
.br
.RI "\fIImplementation of \fBmca_oob_recv_cancel()\fP. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_init_fn_t\fP )(void)"
.br
.RI "\fIHook function called by mca_oob_base_register to allow the oob component a chance to register contact information. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_fini_fn_t\fP )(void)"
.br
.RI "\fICleanup during finalize. \fP"
.ti -1c
.RI "typedef int(* \fBmca_oob_base_module_xcast_fn_t\fP )(orte_process_name_t *root, orte_process_name_t *peers, size_t num_peers, \fBorte_buffer_t\fP *buffer, \fBorte_gpr_trigger_cb_fn_t\fP cbfunc)"
.br
.RI "\fIxcast function for sending common messages to all processes \fP"
.ti -1c
.RI "typedef \fBmca_oob_t\fP *(* \fBmca_oob_base_component_init_fn_t\fP )(int *priority)"
.br
.RI "\fIOOB Component. \fP"
.ti -1c
.RI "typedef \fBmca_oob_base_component_1_0_0_t\fP \fBmca_oob_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.ti -1c
.RI "typedef \fBmca_oob_base_component_1_0_0_t\fP \fBmca_oob_base_component_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.ti -1c
.RI "typedef \fBmca_oob_base_info_t\fP \fBmca_oob_base_info_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.ti -1c
.RI "typedef \fBmca_oob_base_exception_handler_t\fP \fBmca_oob_base_exception_handler_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_oob_base_info_t\fP)"
.br
.RI "\fIdeclare the association structure as a class \fP"
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_oob_base_exception_handler_t\fP)"
.br
.RI "\fIdeclare the association structure as a class \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_oob_base_open\fP (void)"
.br
.RI "\fIFunction for finding and opening either all MCA components, or the one that was specifically requested via a MCA parameter. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_oob_base_init\fP (void)"
.br
.RI "\fIFunction for selecting one module from all those that are available. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_oob_base_module_init\fP (void)"
.br
.RI "\fICalled to request the selected oob components to register their address with the seed deamon. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_oob_base_close\fP (void)"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBmca_oob_t\fP \fBmca_oob\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_oob_base_output\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC char * \fBmca_oob_base_include\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC char * \fBmca_oob_base_exclude\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBopal_list_t\fP \fBmca_oob_base_components\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBopal_list_t\fP \fBmca_oob_base_modules\fP"
.br
.ti -1c
.RI "OMPI_DECLSPEC \fBopal_list_t\fP \fBmca_oob_base_exception_handlers\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Contains the internal functions and typedefs for the use of the oob. 


.SH "Define Documentation"
.PP 
.SS "#define MCA_OOB_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* oob v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* oob v1.0 */ \
  'oob', 1, 0, 0
.fi
Macro for use in components that are of type oob v1.0.0. 
.PP
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBmca_oob_base_module_ping_fn_t\fP)(const orte_process_name_t *, const char *uri, const struct timeval *tv)"
.PP
Implementation of \fBmca_oob_ping()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fItv\fP (IN) Timeout to wait in connection response. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) or OMPI_SUCCESS 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_recv_cancel_fn_t\fP)(orte_process_name_t *peer, int tag)"
.PP
Implementation of \fBmca_oob_recv_cancel()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_recv_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.PP
Implementation of \fBmca_oob_recv()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fItypes\fP (IN) Parallel array to iovecs describing data type of each iovec element. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be MCA_OOB_PEEK to return up to the number of bytes provided in the iovec array without removing the message from the queue. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_recv_nb_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
Implementation of \fBmca_oob_recv_nb()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be MCA_OOB_PEEK to return up to size bytes of msg w/out removing it from the queue, 
.br
\fIcbfunc\fP (IN) Callback function on recv completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_send_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.PP
Implementation of \fBmca_oob_send()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_send_nb_fn_t\fP)(orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.PP
Implementation of \fBmca_oob_send_nb()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.br
\fIcbfunc\fP (IN) Callback function on send completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SS "typedef int(* \fBmca_oob_base_module_set_addr_fn_t\fP)(const orte_process_name_t *, const char *uri)"
.PP
Implementation of mca_oob_base_module_set_addr(). 
.PP
\fBParameters:\fP
.RS 4
\fIaddr\fP Address of seed in component specific uri format. 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int mca_oob_base_init (void)"
.PP
Function for selecting one module from all those that are available. 
.PP
Call the init function on all available modules. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
